Bug 503672 - Review Request: python-webpy - A simple web framework for Python
Review Request: python-webpy - A simple web framework for Python
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Jason Tibbitts
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-02 01:52 EDT by Ray Van Dolson
Modified: 2009-07-22 17:51 EDT (History)
3 users (show)

See Also:
Fixed In Version: 0.32-3.fc10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-20 12:56:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tibbs: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ray Van Dolson 2009-06-02 01:52:59 EDT
Spec: http://rayvd.fedorapeople.org/python-webpy/python-webpy.spec
SRPM: http://rayvd.fedorapeople.org/python-webpy/python-webpy-0.31-1.src.rpm

Description:
web.py is a web framework for python that is as simple as it is
powerful. web.py is in the public domain; you can use it for whatever
purpose with absolutely no restrictions. 

Note:

- The source package contains no documentation.  I can provide a README.Fedora if needed pointing to upstream's web-based docs.
- The source package provides no licensing information.  I will ask upstream to provide this, but per this[1], the software is in the public domain.

[1] http://webpy.org/changes
Comment 1 Ray Van Dolson 2009-06-02 21:34:23 EDT
Per the web.py mailing list, both concerns will be addressed in the 0.32 release (due out shortly).
Comment 2 Jason Tibbitts 2009-07-01 17:01:15 EDT
It's been several more weeks; did that new release ever come out?
Comment 3 Ray Van Dolson 2009-07-01 17:04:10 EDT
It did.  Thanks for the poke.  I'll get a new SRPM put up here shortly...
Comment 4 Ray Van Dolson 2009-07-01 17:58:26 EDT
Alright, new spec and SRPM:

  http://rayvd.fedorapeople.org/python-webpy/python-webpy.spec
  http://rayvd.fedorapeople.org/python-webpy/python-webpy-0.32-1.src.rpm

License file is now included (public domain), but it appears that a component, wsgiserver, is distributed under the cherrypy license[1].  I note that python-cherrypy itself is listed as being under BSD in Fedora, so maybe this license is BSD compatible?  I didn't see it in the Fedora license list under good or bad.

I guess might be worth a post to the legal list.  In any case, I'm not sure how I would indicate multiple licenses in the .spec file.

[1] http://www.cherrypy.org/browser/trunk/cherrypy/LICENSE.txt
Comment 5 Jason Tibbitts 2009-07-01 18:12:29 EDT
That license is indeed BSD.  Compare it against the "New BSD" license at http://fedoraproject.org/wiki/Licensing:BSD.

> In any case, I'm not sure how I would indicate multiple licenses in the .spec 
> file.

This is covered by the packaging guidelines:
http://fedoraproject.org/wiki/Packaging:LicensingGuidelines

This package fails to build for me:

+ /usr/bin/python setup.py install -O1 --skip-build --root /builddir/build/BUILDROOT/python-webpy-0.32-1.fc12.x86_64
running install
error: invalid Python installation: unable to open /usr/lib64/python2.6/config/Makefile (No such file or directory)

I also have a question as to why this package includes a component from another library, but it seems that there are at least two other packages in the distribution besides python-cherrypy itself that include copies of wsgiserver: python-paste-script and deluge.
Comment 6 Ray Van Dolson 2009-07-01 18:17:53 EDT
Yeah, I noticed that precedent as well.

I'll try the build on a 64-bit host and see if I can reproduce.
Comment 7 Ray Van Dolson 2009-07-02 11:53:15 EDT
Hmm, I get this too using koji but it works fine using rpmbuild on my local Fedora 11 system.

Too bad mock on EL5 no longer can build for Fedora 11 without jumping through hoops.

Will keep poking.
Comment 8 Jason Tibbitts 2009-07-02 11:57:37 EDT
You probably just need python-devel.  A local rpmbuild run doesn't really do anything to test that your build dependencies are correct, since the package build with everything that happens to be installed on your system.
Comment 9 Ray Van Dolson 2009-07-02 12:03:35 EDT
Yep, seems to be the case.  My goof, should have known better on that one.  Will have a new SRPM ready shortly (testing in Koji now).
Comment 10 Ray Van Dolson 2009-07-02 12:19:30 EDT
Ok, continuing on with my simple package made hard packaging adventure :)

  http://rayvd.fedorapeople.org/python-webpy/python-webpy.spec
  http://rayvd.fedorapeople.org/python-webpy/python-webpy-0.32-1.src.rpm

Changes:
  * Including correct python-devel BuildRequires
  * Should be meeting multi-license guidelines
  * Included the text of both licenses in the documentation
  * Builds ok in Koji and under mock for EL-5. :-)
Comment 11 Ray Van Dolson 2009-07-02 12:19:54 EDT
If this thing only had an edit feature.  SRPM is here actually:

  http://rayvd.fedorapeople.org/python-webpy/python-webpy-0.32-2.src.rpm
Comment 12 Jason Tibbitts 2009-07-02 18:31:09 EDT
That one builds; rpmlint says:
  python-webpy.noarch: E: non-executable-script /usr/lib/python2.6/site-packages
   /web/utils.py 0644
  python-webpy.noarch: E: non-executable-script /usr/lib/python2.6/site-packages
   /web/application.py 0644
  python-webpy.noarch: E: non-executable-script /usr/lib/python2.6/site-packages
   /web/__init__.py 0644

These happen because those files start with the usual "#!" lines that scripts start with, but they aren't executable.  For some reason, python programmers like to do this although I've never understand why.  Some packagers prefer to fix them by stripping the first line; others just leave the files alone and ignore the rpmlint warning.  You shouldn't generally make them executable.

Please also check the licensing of the files debugerror.py and httpserver.py; they definitely aren't public domain.  Those files have different copyright, but I'm pretty sure they're also under the BSD license.  You should double check and update the comment about the licensing in your spec.

There's a test suite present.  I know some of the tests expect an existing database, which obviously won't work.  I don't know if there are any others that could be run in a %check section at package build time, but it would be good to check.

* source files match upstream.  sha256sum:                
   4e92f0e46731181cbb1daa9d20c5ac4850fa1650144b4f82ed0f296ebeb6f40b  web.py-
   0.32.tar.gz
* package meets naming and versioning guidelines.
* specfile is properly named, is cleanly written and uses macros consistently.
* summary is OK.                                                              
* description is OK.                                                          
* dist tag is present.
* build root is OK.
? license field matches the actual license.
* license is open source-compatible.
* license text included in package.
* latest version is being packaged.
* BuildRequires are proper.
* %clean is present.
* package builds in mock (rawhide, x86_64).
* package installs properly.
* rpmlint has acceptable complaints.
* final provides and requires are sane:
   python-webpy = 0.32-2.fc12
  =
   python(abi) = 2.6

? %check is not present, but there a test suite.
* owns the directories it creates.
* doesn't own any directories it shouldn't.
* no duplicates in %files.
* file permissions are appropriate.
* no generically named files
* code, not content.
* documentation is small, so no -doc subpackage is necessary.
* %docs are not necessary for the proper functioning of the package.

The package review process needs reviewers!  If you haven't done any package
reviews recently, please consider doing one.
Comment 13 Ray Van Dolson 2009-07-07 19:39:18 EDT
Alright, updated spec/srpm:

  http://rayvd.fedorapeople.org/python-webpy/python-webpy.spec
  http://rayvd.fedorapeople.org/python-webpy/python-webpy-0.32-3.src.rpm

Made the following changes:

- Verified licenses for the files you mentioned in their upstream sources 
  and added documentation.
- Removed shebangs from non-scripts
- Enabled the unit tests (the non-db components anyways)
  - Parts of this failed due to a depdance on Python 2.5.  Submitted
    a bug and patch for this upstream.  Applying patch locally so
    that unit tests succeed on Python < 2.5.
Comment 14 Jason Tibbitts 2009-07-08 02:51:54 EDT
Looks good; the license issues seem to be fixed (as far as my inspection has revealed, at least).  The tests are run everything builds correctly and rpmlint is silent.

APPROVED
Comment 15 Ray Van Dolson 2009-07-08 11:03:11 EDT
New Package CVS Request
=======================
Package Name: python-webpy
Short Description: A simple web framework for Python
Owners: rayvd
Branches: F-10 F-11 EL-5 EL-4
InitialCC:
Comment 16 Jason Tibbitts 2009-07-08 12:33:49 EDT
CVS done.
Comment 17 Fedora Update System 2009-07-08 14:37:42 EDT
python-webpy-0.32-3.el4 has been submitted as an update for Fedora EPEL 4.
http://admin.fedoraproject.org/updates/python-webpy-0.32-3.el4
Comment 18 Fedora Update System 2009-07-08 14:37:47 EDT
python-webpy-0.32-3.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/python-webpy-0.32-3.fc10
Comment 19 Fedora Update System 2009-07-08 14:37:52 EDT
python-webpy-0.32-3.el5 has been submitted as an update for Fedora EPEL 5.
http://admin.fedoraproject.org/updates/python-webpy-0.32-3.el5
Comment 20 Fedora Update System 2009-07-08 14:37:57 EDT
python-webpy-0.32-3.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/python-webpy-0.32-3.fc11
Comment 21 Fedora Update System 2009-07-09 01:42:42 EDT
python-webpy-0.32-3.el5 has been pushed to the Fedora EPEL 5 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update python-webpy'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-5/FEDORA-EPEL-2009-0029
Comment 22 Fedora Update System 2009-07-09 01:43:05 EDT
python-webpy-0.32-3.el4 has been pushed to the Fedora EPEL 4 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update python-webpy'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-4/FEDORA-EPEL-2009-0011
Comment 23 Fedora Update System 2009-07-16 03:05:14 EDT
python-webpy-0.32-3.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update python-webpy'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-7602
Comment 24 Fedora Update System 2009-07-16 03:24:47 EDT
python-webpy-0.32-3.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update python-webpy'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-7663
Comment 25 Fedora Update System 2009-07-20 12:56:43 EDT
python-webpy-0.32-3.el4 has been pushed to the Fedora EPEL 4 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 26 Fedora Update System 2009-07-20 12:57:22 EDT
python-webpy-0.32-3.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 27 Fedora Update System 2009-07-22 17:47:38 EDT
python-webpy-0.32-3.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 28 Fedora Update System 2009-07-22 17:51:41 EDT
python-webpy-0.32-3.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.